/*
  GroupMine.cpp - Treat all members of a group as the owner of a mine.

  Jason Hood, 24 October, 2013.

  This plugin regards all members of a group as owners of mines, thus allowing
  all members to be safe during owner_safe_time.  (BTW, owner_safe_time may be
  negative to be safe throughout the mine's lifetime.)

  Install:
	Copy to EXE, add to [Libraries] in dacomsrv.ini.
	Requires and assumes v1.1.
*/

#include "Server.h"

#define NAKED	 __declspec(naked)
#define FASTCALL __fastcall


#define ADDR_MINE ((PBYTE)0x628C128)


DWORD dummy;
#define ProtectX( addr, size ) \
  VirtualProtect( addr, size, PAGE_EXECUTE_READWRITE, &dummy )

#define RELOFS( from, to ) \
  *(PDWORD)(from) = (DWORD)(to) - (DWORD)(from) - 4

#define CALL( from, to ) \
  *(PBYTE)(from) = 0xE8; \
  RELOFS( (DWORD)from+1, to )

#define CALL1( from, to ) \
  CALL( from, to ); \
  ((PBYTE)(from))[5] = 0x90


bool FASTCALL IsOwner( UINT target, UINT launcher )
{
  UINT player = 0;
  PlayerData* pd = NULL;
  while ((pd = Players.traverse_active( pd )) != NULL)
  {
    if (pd->ship == launcher)
    {
      player = pd - Players.playerdata + 1;
      break;
    }
  }
  if (player == 0)
    return false;

  bool group;
  pub::Player::IsGroupMember( player, target, group );
  return group;
}


NAKED
void Mine_Hook()
{
  __asm {
	cmp	edx, 1			// EDX is launcher id
	jb	done			// safe time over
	cmp	[esi+0xb0], edx 	// target id
	je	done
	mov	ecx, [esi+0xb4] 	// target player
	jcxz	done
	call	IsOwner
	cmp	al, 1
  done:
	ret
  }
}


void Patch()
{
  ProtectX( ADDR_MINE, 6 );
  CALL1( ADDR_MINE, Mine_Hook );
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
    Patch();

  return TRUE;
}
